pragma Warnings (Off);
pragma Ada_95;
pragma Source_File_Name (ada_main, Spec_File_Name => "b__templates2ada.ads");
pragma Source_File_Name (ada_main, Body_File_Name => "b__templates2ada.adb");
pragma Suppress (Overflow_Check);

with System.Restrictions;
with Ada.Exceptions;

package body ada_main is

   E018 : Short_Integer; pragma Import (Ada, E018, "ada__exceptions_E");
   E014 : Short_Integer; pragma Import (Ada, E014, "system__soft_links_E");
   E012 : Short_Integer; pragma Import (Ada, E012, "system__exception_table_E");
   E021 : Short_Integer; pragma Import (Ada, E021, "system__exceptions_E");
   E051 : Short_Integer; pragma Import (Ada, E051, "system__soft_links__initialize_E");
   E062 : Short_Integer; pragma Import (Ada, E062, "ada__containers_E");
   E068 : Short_Integer; pragma Import (Ada, E068, "ada__io_exceptions_E");
   E198 : Short_Integer; pragma Import (Ada, E198, "ada__numerics_E");
   E009 : Short_Integer; pragma Import (Ada, E009, "ada__strings_E");
   E072 : Short_Integer; pragma Import (Ada, E072, "ada__strings__utf_encoding_E");
   E159 : Short_Integer; pragma Import (Ada, E159, "gnat_E");
   E104 : Short_Integer; pragma Import (Ada, E104, "interfaces__c_E");
   E218 : Short_Integer; pragma Import (Ada, E218, "interfaces__c__strings_E");
   E106 : Short_Integer; pragma Import (Ada, E106, "system__os_lib_E");
   E234 : Short_Integer; pragma Import (Ada, E234, "system__task_info_E");
   E078 : Short_Integer; pragma Import (Ada, E078, "ada__tags_E");
   E070 : Short_Integer; pragma Import (Ada, E070, "ada__strings__text_buffers_E");
   E067 : Short_Integer; pragma Import (Ada, E067, "ada__streams_E");
   E144 : Short_Integer; pragma Import (Ada, E144, "system__file_control_block_E");
   E093 : Short_Integer; pragma Import (Ada, E093, "system__finalization_root_E");
   E065 : Short_Integer; pragma Import (Ada, E065, "ada__finalization_E");
   E141 : Short_Integer; pragma Import (Ada, E141, "system__file_io_E");
   E154 : Short_Integer; pragma Import (Ada, E154, "ada__streams__stream_io_E");
   E150 : Short_Integer; pragma Import (Ada, E150, "system__storage_pools_E");
   E146 : Short_Integer; pragma Import (Ada, E146, "system__finalization_masters_E");
   E170 : Short_Integer; pragma Import (Ada, E170, "system__storage_pools__subpools_E");
   E102 : Short_Integer; pragma Import (Ada, E102, "ada__calendar_E");
   E194 : Short_Integer; pragma Import (Ada, E194, "ada__calendar__time_zones_E");
   E158 : Short_Integer; pragma Import (Ada, E158, "ada__text_io_E");
   E189 : Short_Integer; pragma Import (Ada, E189, "gnat__calendar_E");
   E055 : Short_Integer; pragma Import (Ada, E055, "ada__strings__maps_E");
   E059 : Short_Integer; pragma Import (Ada, E059, "ada__strings__maps__constants_E");
   E126 : Short_Integer; pragma Import (Ada, E126, "ada__strings__unbounded_E");
   E207 : Short_Integer; pragma Import (Ada, E207, "system__regpat_E");
   E228 : Short_Integer; pragma Import (Ada, E228, "system__task_primitives__operations_E");
   E201 : Short_Integer; pragma Import (Ada, E201, "gnat__calendar__time_io_E");
   E163 : Short_Integer; pragma Import (Ada, E163, "gnat__directory_operations_E");
   E166 : Short_Integer; pragma Import (Ada, E166, "system__pool_global_E");
   E152 : Short_Integer; pragma Import (Ada, E152, "system__regexp_E");
   E100 : Short_Integer; pragma Import (Ada, E100, "ada__directories_E");
   E161 : Short_Integer; pragma Import (Ada, E161, "gnat__command_line_E");
   E248 : Short_Integer; pragma Import (Ada, E248, "system__tasking__initialization_E");
   E258 : Short_Integer; pragma Import (Ada, E258, "system__tasking__protected_objects_E");
   E260 : Short_Integer; pragma Import (Ada, E260, "system__tasking__protected_objects__entries_E");
   E256 : Short_Integer; pragma Import (Ada, E256, "system__tasking__queuing_E");
   E220 : Short_Integer; pragma Import (Ada, E220, "templates_parser_tasking_E");
   E180 : Short_Integer; pragma Import (Ada, E180, "templates_parser_E");
   E212 : Short_Integer; pragma Import (Ada, E212, "templates_parser__input_E");
   E214 : Short_Integer; pragma Import (Ada, E214, "templates_parser__utils_E");

   Sec_Default_Sized_Stacks : array (1 .. 1) of aliased System.Secondary_Stack.SS_Stack (System.Parameters.Runtime_Default_Sec_Stack_Size);

   Local_Priority_Specific_Dispatching : constant String := "";
   Local_Interrupt_States : constant String := "";

   Is_Elaborated : Boolean := False;

   procedure finalize_library is
   begin
      declare
         procedure F1;
         pragma Import (Ada, F1, "templates_parser__finalize_body");
      begin
         E180 := E180 - 1;
         F1;
      end;
      declare
         procedure F2;
         pragma Import (Ada, F2, "templates_parser__finalize_spec");
      begin
         F2;
      end;
      declare
         procedure F3;
         pragma Import (Ada, F3, "templates_parser_tasking__finalize_body");
      begin
         E220 := E220 - 1;
         F3;
      end;
      E260 := E260 - 1;
      declare
         procedure F4;
         pragma Import (Ada, F4, "system__tasking__protected_objects__entries__finalize_spec");
      begin
         F4;
      end;
      declare
         procedure F5;
         pragma Import (Ada, F5, "ada__directories__finalize_body");
      begin
         E100 := E100 - 1;
         F5;
      end;
      declare
         procedure F6;
         pragma Import (Ada, F6, "ada__directories__finalize_spec");
      begin
         F6;
      end;
      E152 := E152 - 1;
      declare
         procedure F7;
         pragma Import (Ada, F7, "system__regexp__finalize_spec");
      begin
         F7;
      end;
      E166 := E166 - 1;
      declare
         procedure F8;
         pragma Import (Ada, F8, "system__pool_global__finalize_spec");
      begin
         F8;
      end;
      E126 := E126 - 1;
      declare
         procedure F9;
         pragma Import (Ada, F9, "ada__strings__unbounded__finalize_spec");
      begin
         F9;
      end;
      E158 := E158 - 1;
      declare
         procedure F10;
         pragma Import (Ada, F10, "ada__text_io__finalize_spec");
      begin
         F10;
      end;
      E170 := E170 - 1;
      declare
         procedure F11;
         pragma Import (Ada, F11, "system__storage_pools__subpools__finalize_spec");
      begin
         F11;
      end;
      E146 := E146 - 1;
      declare
         procedure F12;
         pragma Import (Ada, F12, "system__finalization_masters__finalize_spec");
      begin
         F12;
      end;
      E154 := E154 - 1;
      declare
         procedure F13;
         pragma Import (Ada, F13, "ada__streams__stream_io__finalize_spec");
      begin
         F13;
      end;
      declare
         procedure F14;
         pragma Import (Ada, F14, "system__file_io__finalize_body");
      begin
         E141 := E141 - 1;
         F14;
      end;
      declare
         procedure Reraise_Library_Exception_If_Any;
            pragma Import (Ada, Reraise_Library_Exception_If_Any, "__gnat_reraise_library_exception_if_any");
      begin
         Reraise_Library_Exception_If_Any;
      end;
   end finalize_library;

   procedure adafinal is
      procedure s_stalib_adafinal;
      pragma Import (Ada, s_stalib_adafinal, "system__standard_library__adafinal");

      procedure Runtime_Finalize;
      pragma Import (C, Runtime_Finalize, "__gnat_runtime_finalize");

   begin
      if not Is_Elaborated then
         return;
      end if;
      Is_Elaborated := False;
      Runtime_Finalize;
      s_stalib_adafinal;
   end adafinal;

   type No_Param_Proc is access procedure;
   pragma Favor_Top_Level (No_Param_Proc);

   procedure adainit is
      Main_Priority : Integer;
      pragma Import (C, Main_Priority, "__gl_main_priority");
      Time_Slice_Value : Integer;
      pragma Import (C, Time_Slice_Value, "__gl_time_slice_val");
      WC_Encoding : Character;
      pragma Import (C, WC_Encoding, "__gl_wc_encoding");
      Locking_Policy : Character;
      pragma Import (C, Locking_Policy, "__gl_locking_policy");
      Queuing_Policy : Character;
      pragma Import (C, Queuing_Policy, "__gl_queuing_policy");
      Task_Dispatching_Policy : Character;
      pragma Import (C, Task_Dispatching_Policy, "__gl_task_dispatching_policy");
      Priority_Specific_Dispatching : System.Address;
      pragma Import (C, Priority_Specific_Dispatching, "__gl_priority_specific_dispatching");
      Num_Specific_Dispatching : Integer;
      pragma Import (C, Num_Specific_Dispatching, "__gl_num_specific_dispatching");
      Main_CPU : Integer;
      pragma Import (C, Main_CPU, "__gl_main_cpu");
      Interrupt_States : System.Address;
      pragma Import (C, Interrupt_States, "__gl_interrupt_states");
      Num_Interrupt_States : Integer;
      pragma Import (C, Num_Interrupt_States, "__gl_num_interrupt_states");
      Unreserve_All_Interrupts : Integer;
      pragma Import (C, Unreserve_All_Interrupts, "__gl_unreserve_all_interrupts");
      Exception_Tracebacks : Integer;
      pragma Import (C, Exception_Tracebacks, "__gl_exception_tracebacks");
      Detect_Blocking : Integer;
      pragma Import (C, Detect_Blocking, "__gl_detect_blocking");
      Default_Stack_Size : Integer;
      pragma Import (C, Default_Stack_Size, "__gl_default_stack_size");
      Default_Secondary_Stack_Size : System.Parameters.Size_Type;
      pragma Import (C, Default_Secondary_Stack_Size, "__gnat_default_ss_size");
      Bind_Env_Addr : System.Address;
      pragma Import (C, Bind_Env_Addr, "__gl_bind_env_addr");

      procedure Runtime_Initialize (Install_Handler : Integer);
      pragma Import (C, Runtime_Initialize, "__gnat_runtime_initialize");

      Finalize_Library_Objects : No_Param_Proc;
      pragma Import (C, Finalize_Library_Objects, "__gnat_finalize_library_objects");
      Binder_Sec_Stacks_Count : Natural;
      pragma Import (Ada, Binder_Sec_Stacks_Count, "__gnat_binder_ss_count");
      Default_Sized_SS_Pool : System.Address;
      pragma Import (Ada, Default_Sized_SS_Pool, "__gnat_default_ss_pool");

   begin
      if Is_Elaborated then
         return;
      end if;
      Is_Elaborated := True;
      Main_Priority := -1;
      Time_Slice_Value := -1;
      WC_Encoding := 'b';
      Locking_Policy := ' ';
      Queuing_Policy := ' ';
      Task_Dispatching_Policy := ' ';
      System.Restrictions.Run_Time_Restrictions :=
        (Set =>
          (False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, True, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False),
         Value => (0, 0, 0, 0, 0, 0, 0, 0, 0, 0),
         Violated =>
          (True, False, False, False, True, True, False, False, 
           True, False, False, True, True, True, True, False, 
           False, False, False, True, False, False, True, True, 
           False, True, True, False, True, True, True, True, 
           False, True, False, False, False, True, False, False, 
           True, False, True, False, True, True, False, False, 
           True, True, False, False, True, True, False, True, 
           False, False, False, False, False, False, False, False, 
           False, True, True, True, False, False, True, False, 
           True, True, True, False, True, True, False, True, 
           True, True, True, False, False, False, True, False, 
           False, False, False, True, False, False, False, False, 
           True, False),
         Count => (0, 0, 0, 2, 0, 0, 0, 0, 1, 0),
         Unknown => (False, False, False, False, False, False, False, False, True, False));
      Priority_Specific_Dispatching :=
        Local_Priority_Specific_Dispatching'Address;
      Num_Specific_Dispatching := 0;
      Main_CPU := -1;
      Interrupt_States := Local_Interrupt_States'Address;
      Num_Interrupt_States := 0;
      Unreserve_All_Interrupts := 0;
      Exception_Tracebacks := 1;
      Detect_Blocking := 0;
      Default_Stack_Size := -1;

      ada_main'Elab_Body;
      Default_Secondary_Stack_Size := System.Parameters.Runtime_Default_Sec_Stack_Size;
      Binder_Sec_Stacks_Count := 1;
      Default_Sized_SS_Pool := Sec_Default_Sized_Stacks'Address;

      Runtime_Initialize (1);

      Finalize_Library_Objects := finalize_library'access;

      Ada.Exceptions'Elab_Spec;
      System.Soft_Links'Elab_Spec;
      System.Exception_Table'Elab_Body;
      E012 := E012 + 1;
      System.Exceptions'Elab_Spec;
      E021 := E021 + 1;
      System.Soft_Links.Initialize'Elab_Body;
      E051 := E051 + 1;
      E014 := E014 + 1;
      E018 := E018 + 1;
      Ada.Containers'Elab_Spec;
      E062 := E062 + 1;
      Ada.Io_Exceptions'Elab_Spec;
      E068 := E068 + 1;
      Ada.Numerics'Elab_Spec;
      E198 := E198 + 1;
      Ada.Strings'Elab_Spec;
      E009 := E009 + 1;
      Ada.Strings.Utf_Encoding'Elab_Spec;
      E072 := E072 + 1;
      Gnat'Elab_Spec;
      E159 := E159 + 1;
      Interfaces.C'Elab_Spec;
      E104 := E104 + 1;
      Interfaces.C.Strings'Elab_Spec;
      E218 := E218 + 1;
      System.Os_Lib'Elab_Body;
      E106 := E106 + 1;
      System.Task_Info'Elab_Spec;
      E234 := E234 + 1;
      Ada.Tags'Elab_Spec;
      Ada.Tags'Elab_Body;
      E078 := E078 + 1;
      Ada.Strings.Text_Buffers'Elab_Spec;
      E070 := E070 + 1;
      Ada.Streams'Elab_Spec;
      E067 := E067 + 1;
      System.File_Control_Block'Elab_Spec;
      E144 := E144 + 1;
      System.Finalization_Root'Elab_Spec;
      E093 := E093 + 1;
      Ada.Finalization'Elab_Spec;
      E065 := E065 + 1;
      System.File_Io'Elab_Body;
      E141 := E141 + 1;
      Ada.Streams.Stream_Io'Elab_Spec;
      E154 := E154 + 1;
      System.Storage_Pools'Elab_Spec;
      E150 := E150 + 1;
      System.Finalization_Masters'Elab_Spec;
      System.Finalization_Masters'Elab_Body;
      E146 := E146 + 1;
      System.Storage_Pools.Subpools'Elab_Spec;
      E170 := E170 + 1;
      Ada.Calendar'Elab_Spec;
      Ada.Calendar'Elab_Body;
      E102 := E102 + 1;
      Ada.Calendar.Time_Zones'Elab_Spec;
      E194 := E194 + 1;
      Ada.Text_Io'Elab_Spec;
      Ada.Text_Io'Elab_Body;
      E158 := E158 + 1;
      Gnat.Calendar'Elab_Spec;
      E189 := E189 + 1;
      Ada.Strings.Maps'Elab_Spec;
      E055 := E055 + 1;
      Ada.Strings.Maps.Constants'Elab_Spec;
      E059 := E059 + 1;
      Ada.Strings.Unbounded'Elab_Spec;
      E126 := E126 + 1;
      System.Regpat'Elab_Spec;
      E207 := E207 + 1;
      System.Task_Primitives.Operations'Elab_Body;
      E228 := E228 + 1;
      Gnat.Calendar.Time_Io'Elab_Spec;
      E201 := E201 + 1;
      Gnat.Directory_Operations'Elab_Spec;
      Gnat.Directory_Operations'Elab_Body;
      E163 := E163 + 1;
      System.Pool_Global'Elab_Spec;
      E166 := E166 + 1;
      System.Regexp'Elab_Spec;
      E152 := E152 + 1;
      Ada.Directories'Elab_Spec;
      Ada.Directories'Elab_Body;
      E100 := E100 + 1;
      Gnat.Command_Line'Elab_Spec;
      Gnat.Command_Line'Elab_Body;
      E161 := E161 + 1;
      System.Tasking.Initialization'Elab_Body;
      E248 := E248 + 1;
      System.Tasking.Protected_Objects'Elab_Body;
      E258 := E258 + 1;
      System.Tasking.Protected_Objects.Entries'Elab_Spec;
      E260 := E260 + 1;
      System.Tasking.Queuing'Elab_Body;
      E256 := E256 + 1;
      Templates_Parser_Tasking'Elab_Body;
      E220 := E220 + 1;
      Templates_Parser'Elab_Spec;
      Templates_Parser.Input'Elab_Spec;
      E212 := E212 + 1;
      Templates_Parser.Utils'Elab_Spec;
      E214 := E214 + 1;
      Templates_Parser'Elab_Body;
      E180 := E180 + 1;
   end adainit;

   procedure Ada_Main_Program;
   pragma Import (Ada, Ada_Main_Program, "_ada_templates2ada");

   function main
     (argc : Integer;
      argv : System.Address;
      envp : System.Address)
      return Integer
   is
      procedure Initialize (Addr : System.Address);
      pragma Import (C, Initialize, "__gnat_initialize");

      procedure Finalize;
      pragma Import (C, Finalize, "__gnat_finalize");
      SEH : aliased array (1 .. 2) of Integer;

      Ensure_Reference : aliased System.Address := Ada_Main_Program_Name'Address;
      pragma Volatile (Ensure_Reference);

   begin
      if gnat_argc = 0 then
         gnat_argc := argc;
         gnat_argv := argv;
      end if;
      gnat_envp := envp;

      Initialize (SEH'Address);
      adainit;
      Ada_Main_Program;
      adafinal;
      Finalize;
      return (gnat_exit_status);
   end;

--  BEGIN Object file/option list
   --   /builddir/build/BUILD/templates_parser-11.8.0/.build/s390x-redhat-linux/release/relocatable/tobj/templates2ada.o
   --   -L/builddir/build/BUILD/templates_parser-11.8.0/.build/s390x-redhat-linux/release/relocatable/tobj/
   --   -L/builddir/build/BUILD/templates_parser-11.8.0/.build/s390x-redhat-linux/release/relocatable/tobj/
   --   -L/builddir/build/BUILD/templates_parser-11.8.0/.build/s390x-redhat-linux/release/relocatable/lib/
   --   -L/usr/lib64/xmlada/
   --   -L/usr/lib/gcc/s390x-redhat-linux/12/adalib/
   --   -shared
   --   -lgnarl-12
   --   -lgnat-12
   --   -lrt
   --   -lpthread
--  END Object file/option list   

end ada_main;
